// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.vessel.feature.physical;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * Caractéristiques d'un navire, sur une période donnée.
 * </p>
 * <p>
 * Si le navire est inscrit au FPC, les caractéristiques FPC sont
 * utilisées (jauge_ums et jauge_brute).
 * </p>
 * <p>
 * REMARQUE : les données ramenées depuis Harmonie sont fusionnées
 * entre les caractéristiques FPC (à utiliser de préférence si
 * présent), et les caractéristiques d'autres sources.
 * </p>
 * <p>
 * Nombre de lignes : 67375
 * </p>
 */
public abstract class VesselFeatures
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 4099560918315500551L;

    private java.lang.Integer id;

    /**
     * 
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.util.Date startDateTime;

    /**
     * <p>
     * Date de début de validité des caractéristiques navires.
     * </p>
     */
    public java.util.Date getStartDateTime()
    {
        return this.startDateTime;
    }

    public void setStartDateTime(java.util.Date startDateTime)
    {
        this.startDateTime = startDateTime;
    }

    private java.util.Date endDateTime;

    /**
     * <p>
     * Date de fin de validité des caractéristiques navires.
     * </p>
     */
    public java.util.Date getEndDateTime()
    {
        return this.endDateTime;
    }

    public void setEndDateTime(java.util.Date endDateTime)
    {
        this.endDateTime = endDateTime;
    }

    private java.lang.String name;

    /**
     * <p>
     * Nom du navire pour la période début-fin
     * </p>
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.lang.String exteriorMarking;

    /**
     * <p>
     * Marquage extérieur.
     * </p>
     * <p>
     * par exemple : "BR 101717"
     * </p>
     */
    public java.lang.String getExteriorMarking()
    {
        return this.exteriorMarking;
    }

    public void setExteriorMarking(java.lang.String exteriorMarking)
    {
        this.exteriorMarking = exteriorMarking;
    }

    private java.lang.Float administrativePower;

    /**
     * <p>
     * Puissance principale administrative (en Kw) du navire pour la
     * période début-fin.
     * </p>
     * <p>
     * Selon le règlement (CEE) no 2930/86
     * </p>
     */
    public java.lang.Float getAdministrativePower()
    {
        return this.administrativePower;
    }

    public void setAdministrativePower(java.lang.Float administrativePower)
    {
        this.administrativePower = administrativePower;
    }

    private java.lang.Float auxiliaryPower;

    /**
     * <p>
     * Puissance auxiliaire en kW.
     * </p>
     * <p>
     * Reprend toute puissance installée non comprise sous la rubrique
     * Puissance administrative
     * </p>
     */
    public java.lang.Float getAuxiliaryPower()
    {
        return this.auxiliaryPower;
    }

    public void setAuxiliaryPower(java.lang.Float auxiliaryPower)
    {
        this.auxiliaryPower = auxiliaryPower;
    }

    private java.lang.Integer grossTonnageGT;

    /**
     * <p>
     * Tonnage GT (Gross Tonnage), exprimé en UMS (Universal
     * Measurement System), et multiplié par 100.
     * </p>
     * <p>
     * Il s'agit d'un tonnage reconnu internationnellement.
     * </p>
     * <p>
     * La France s'est engagé à fournir un tonnage GT pour tous les
     * navires de plus de 24m, par application du Décret N°725 du 10
     * août 1982.
     * </p>
     * <p>
     * ------
     * </p>
     * <p>
     * Jauge GT ou Gross Tonnage en accord avec la Convention
     * internationale de 1969 (règlement de Londres, International
     * Convention on Tonnage Measurement of Ships, London, 1969 (in use
     * since 1996) for vessels >= 15m"
     * </p>
     * <p>
     * Par décret n° 82-725 du 10 août 1982, publié au Journal officiel
     * du 20 août 1982, la Convention internationale de 1969 sur le
     * jaugeage des navires est entrée en vigueur en France le 18
     * juillet 1982. Le règlement de jaugeage annexé à cette convention
     * conclue à Londres le 23 juin 1969 devient règlement
     * international. La jauge, de Londres comprend la jauge brute et
     * la jauge nette et doit être calculée selon les règles énoncées
     * par la convention internationale de 1969 sur le jaugeage des
     * navires. La jauge brute est obtenue à partir des mesures
     * pratiquées sur tous les espaces fermés d'un navire, à
     * l'exception des espaces exclus par les règles de la convention
     * précitée. La jauge nette est déterminée par les dimensions des
     * espaces réservés au fret et par le nombre des passagers.
     * </p>
     * <p>
     * La jauge de Londres est reprise sur le "certificat international
     * de jaugeage des navires (1969)".
     * </p>
     */
    public java.lang.Integer getGrossTonnageGT()
    {
        return this.grossTonnageGT;
    }

    public void setGrossTonnageGT(java.lang.Integer grossTonnageGT)
    {
        this.grossTonnageGT = grossTonnageGT;
    }

    private java.lang.Integer grossTonnageGRT;

    /**
     * <p>
     * Tonnage du navire, ou jauge Brute, exprimé en TJB (Tonnage de
     * Jauge Brute), et multiplié par 100.
     * </p>
     * <p>
     * ------
     * </p>
     * <p>
     * Tonnage (GRT) 'Gross Registered Tonnage' en accord avec la
     * convention d'Oslo (1947) (en emploi en France jusqu'en 1995,
     * toujours utilisé dans certains pays).
     * </p>
     * <p>
     * (GRT represent the total cubic measured content of the
     * permanently enclosed spaces of a vessel, with some allowances or
     * deductions for exempt spaces such as living quarters [1 gross
     * register ton = 100 cubic feet = 2.83 cubic metres]).
     * </p>
     */
    public java.lang.Integer getGrossTonnageGRT()
    {
        return this.grossTonnageGRT;
    }

    public void setGrossTonnageGRT(java.lang.Integer grossTonnageGRT)
    {
        this.grossTonnageGRT = grossTonnageGRT;
    }

    private java.lang.Integer lengthOverAll;

    /**
     * <p>
     * Longueur hors tout (Length OverAll) en cm du navire pour la
     * période début-fin.
     * </p>
     * <p>
     * Définie selon le règlement (CEE) no 2930/86.
     * </p>
     */
    public java.lang.Integer getLengthOverAll()
    {
        return this.lengthOverAll;
    }

    public void setLengthOverAll(java.lang.Integer lengthOverAll)
    {
        this.lengthOverAll = lengthOverAll;
    }

    private java.lang.Integer lengthBeetweenPerpendiculars;

    /**
     * <p>
     * Longueur entre perpendiculaires (Length Between Perpendiculars)
     * en cm.
     * </p>
     * <p>
     * Définie selon le règlement (CEE) no 2930/86.
     * </p>
     */
    public java.lang.Integer getLengthBeetweenPerpendiculars()
    {
        return this.lengthBeetweenPerpendiculars;
    }

    public void setLengthBeetweenPerpendiculars(java.lang.Integer lengthBeetweenPerpendiculars)
    {
        this.lengthBeetweenPerpendiculars = lengthBeetweenPerpendiculars;
    }

    private java.lang.Integer constructionYear;

    /**
     * <p>
     * Année de construction du navire
     * </p>
     */
    public java.lang.Integer getConstructionYear()
    {
        return this.constructionYear;
    }

    public void setConstructionYear(java.lang.Integer constructionYear)
    {
        this.constructionYear = constructionYear;
    }

    private java.lang.String IRCS;

    /**
     * <p>
     * Indicatif radio international du navire (IRCS)
     * </p>
     */
    public java.lang.String getIRCS()
    {
        return this.IRCS;
    }

    public void setIRCS(java.lang.String IRCS)
    {
        this.IRCS = IRCS;
    }

    private java.lang.Boolean hasVMS;

    /**
     * <p>
     * indique si le navire dispose d'un système VMS ou non.
     * </p>
     */
    public java.lang.Boolean getHasVMS()
    {
        return this.hasVMS;
    }

    public void setHasVMS(java.lang.Boolean hasVMS)
    {
        this.hasVMS = hasVMS;
    }

    private java.lang.Boolean isFPC = java.lang.Boolean.valueOf(false);

    /**
     * <p>
     * Indique si le navire est inscrit au fichier FPC ou non.
     * </p>
     */
    public java.lang.Boolean getIsFPC()
    {
        return this.isFPC;
    }

    public void setIsFPC(java.lang.Boolean isFPC)
    {
        this.isFPC = isFPC;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.vessel.Vessel getVessel()
    {
        return this.vessel;
    }

    public void setVessel(fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel)
    {
        this.vessel = vessel;
    }


    private fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue hullMaterial;

    /**
     * <p>
     * Matériausx de la coque (ex : Bois, Métal, Plastique, etc).
     * </p>
     * <p>
     * cf PMFM "HULL_METRIAL".
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue getHullMaterial()
    {
        return this.hullMaterial;
    }

    public void setHullMaterial(fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue hullMaterial)
    {
        this.hullMaterial = hullMaterial;
    }


    private fr.ifremer.adagio.core.dao.referential.location.Location basePortLocation;

    /**
     * <p>
     * Base port
     * </p>
     * <p>
     * see http://www.fao.org/fi/glossary/default.asp
     * </p>
     * <p>
     * FAO (1998): Guidelines for the routine collection of capture
     * fishery data. FAO Fish. Tech. Pap, 382: 113 p
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.location.Location getBasePortLocation()
    {
        return this.basePortLocation;
    }

    public void setBasePortLocation(fr.ifremer.adagio.core.dao.referential.location.Location basePortLocation)
    {
        this.basePortLocation = basePortLocation;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof VesselFeatures))
        {
            return false;
        }
        final VesselFeatures that = (VesselFeatures)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeatures}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeatures}.
         */
        public static fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeatures newInstance()
        {
            final fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeatures entity = new fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeaturesImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeatures}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeatures newInstance(java.util.Date startDateTime, java.lang.Boolean isFPC, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel)
        {
            final fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeatures entity = newInstance();
            entity.setStartDateTime(startDateTime);
            entity.setIsFPC(isFPC);
            entity.setVessel(vessel);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeatures}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeatures newInstance(java.util.Date startDateTime, java.util.Date endDateTime, java.lang.String name, java.lang.String exteriorMarking, java.lang.Float administrativePower, java.lang.Float auxiliaryPower, java.lang.Integer grossTonnageGT, java.lang.Integer grossTonnageGRT, java.lang.Integer lengthOverAll, java.lang.Integer lengthBeetweenPerpendiculars, java.lang.Integer constructionYear, java.lang.String IRCS, java.lang.Boolean hasVMS, java.lang.Boolean isFPC, java.sql.Timestamp updateDate, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel, fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue hullMaterial, fr.ifremer.adagio.core.dao.referential.location.Location basePortLocation)
        {
            final fr.ifremer.adagio.core.dao.data.vessel.feature.physical.VesselFeatures entity = newInstance();
            entity.setStartDateTime(startDateTime);
            entity.setEndDateTime(endDateTime);
            entity.setName(name);
            entity.setExteriorMarking(exteriorMarking);
            entity.setAdministrativePower(administrativePower);
            entity.setAuxiliaryPower(auxiliaryPower);
            entity.setGrossTonnageGT(grossTonnageGT);
            entity.setGrossTonnageGRT(grossTonnageGRT);
            entity.setLengthOverAll(lengthOverAll);
            entity.setLengthBeetweenPerpendiculars(lengthBeetweenPerpendiculars);
            entity.setConstructionYear(constructionYear);
            entity.setIRCS(IRCS);
            entity.setHasVMS(hasVMS);
            entity.setIsFPC(isFPC);
            entity.setUpdateDate(updateDate);
            entity.setVessel(vessel);
            entity.setHullMaterial(hullMaterial);
            entity.setBasePortLocation(basePortLocation);
            return entity;
        }
    }
    
// VesselFeatures.java merge-point
}